﻿
 local L = GladiatorVoiceAlerter.L
 local version = "0.2"

 local GVA_DB
---------------------------------------------------------------------------------------------------------
	-- local poutoutou = {"bijou", "caillou", "chou", "genou", "hibou", "joujou", "pou", "bijou", "caillou", "chou", "genou", "hibou", "joujou", "pou", "bijou", "caillou", "chou", "genou", "hibou", "joujou", "pou"}
---------------------------------------------------------------------------------------------------------
 function GladiatorVoiceAlerter:CreateOptionsMenu()
 -- print(select(4, GetBuildInfo())) -- 70000 / 60200
 local GVA_DB = GladiatorVoiceAlerter.MainDB.profile
 local GVA_IsDisabled = {}; GladiatorVoiceAlerter.GVA_IsDisabled = GVA_IsDisabled
 local GVA_OUTPUT = {	["MASTER"] = 	L["Master"] 	or "Master",
						["SFX"] = 		L["SFX"] 		or "SFX",
						["AMBIENCE"] = 	L["Ambience"] 	or "Ambience",
						["MUSIC"] = 	L["Music"] 		or "Music"}
 local LastListeBG -- MENU DEROULANT
 
 local LanguageList = {}
 for Locale,a in pairs(GladiatorVoiceAlerter.GVA_VoicePack) do
	for k,v in pairs(a) do
		if k == "Nom" then
			LanguageList[Locale] = v
		end
	end
 end
 GladiatorVoiceAlerter.LanguageList = LanguageList
------------M-E-M-E----P-A-S----P-E-U-R------------------------------------------------------------------
	local MPP = {
---------------------------------------------------------------------------------------------------------
		MenuTop = {
			General = {
				Type = "Poussoir",
				Etat = false,
				Texte = L["MenuTop_General"] or "|cffFF7D0AG|reneral / |cffFF7D0AV|roices",
				Place = 6,
				TailleH = 30,
				TailleL = 210,
				Scenario = "AuTop!",
			},
			Abilities = {
				Type = "Poussoir",
				Etat = false,
				Texte = L["MenuTop_Abilities"] or "|cffFF7D0AA|rbilities",
				Place = 6+210,
				TailleH = 30,
				TailleL = 130,
				Scenario = "AuTop!",
			},
			Custom = {
				Type = "Poussoir",
				Etat = false,
				Texte = L["MenuTop_Custom"] or "|cffFF7D0AC|rustom",
				Place = 6+210+130,
				TailleH = 30,
				TailleL = 130,
				Scenario = "AuTop!",
			},
			MenuLSM = {
				Type = "Poussoir",
				Etat = false,
				Texte = L["MenuTop_LSM"] or "|cffFF7D0AL|rSM",
				Place = 6+210+130*2,
				TailleH = 30,
				TailleL = 130,
				Scenario = "AuTop!",
			},
			Added = {
				Type = "Poussoir",
				Etat = false,
				-- Texte = "|TInterface/Calendar/EventNotification:26|t",
				-- Texte = "|TInterface/FriendsFrame/InformationIcon:26|t",
				-- Texte = "|TInterface/FriendsFrame/InformationIcon-Highlight:26|t",
				Texte = "|TInterface/GossipFrame/ActiveLegendaryQuestIcon:20|t",
				-- Texte = "|TInterface/GossipFrame/ActiveQuestIcon:20|t",
				-- Texte = "|TInterface/GossipFrame/AvailableLegendaryQuestIcon:20|t",
				-- Texte = "|TInterface/GossipFrame/AvailableQuestIcon:20|t",
				Place = 6+210+130*3,
				TailleH = 30,
				TailleL = 30,
				Scenario = "AuTop!",
			},
			Info = {
				Type = "Poussoir",
				Etat = false,
				-- Texte = "|TInterface/Calendar/EventNotification:26|t",
				-- Texte = "|TInterface/FriendsFrame/InformationIcon:26|t",
				-- Texte = "|TInterface/FriendsFrame/InformationIcon-Highlight:26|t",
				-- Texte = "|TInterface/GossipFrame/ActiveLegendaryQuestIcon:20|t",
				-- Texte = "|TInterface/GossipFrame/ActiveQuestIcon:20|t",
				-- Texte = "|TInterface/GossipFrame/AvailableLegendaryQuestIcon:20|t",
				Texte = "|TInterface/GossipFrame/AvailableQuestIcon:20|t",
				Place = 6+210+130*3+30,
				TailleH = 30,
				TailleL = 30,
				Scenario = "AuTop!",
			},
			Close = {
				Type = "Poussoir",
				Etat = false,
				-- Texte = "|TInterface/FriendsFrame/UI-Toast-CloseButton-Up:26|t",
				-- Texte = "|TInterface/GLUES/LOGIN/Glues-CheckBox-Check:26|t",
				Texte = "|TInterface/Scenarios/ScenarioIcon-Fail:26|t",
				-- Texte = "|TInterface/WORLDSTATEFRAME/SkullBones:80|t", -- Mhhh Icone crâne intéressante
				Place = 6+210+130*3+30*2,
				TailleH = 30,
				TailleL = 30,
				Scenario = function(self) GladiatorVoiceAlerter.MainGVAframe:Hide();GladiatorVoiceAlerter.MainGVAframe.MainModelFrame:Hide() end,
			}
		},
		MenuIn = {
			General = {
				General = {
					[1] = {
						[1] = {
							Nom = "ActivationAddOn_",
							Type = "LigneDeSeparation",
							Texte = L["General options"] or "General options"
						},
						[2] = {
							Type = "Encoche",
							Etat = false,
							Nom = "EnableGVA_",
							Texte = L["Enable GladiatorVA"] or "Enable GladiatorVA",
							Description = L["EnableGVA_Desc"] or "Activate or deactivate Gladiator Voice Alerter",
						},
						[3] = {
							Type = "Encoche",
							Etat = false,
							Nom = "MinimapIcon_",
							Texte = L["Enable minimap Icon"] or "Enable minimap Icon",
							Description = L["MinimapIcon_Desc"] or "Show / Hide de minimap Icon",
							Scenario = {{["func"] = function() GladiatorVoiceAlerter:CommandTheBunnies("toggle") end}},
						}
					},
					[2] = {
						[1] = {
							Type = "LigneDeSeparation",
							Nom = "AreaActivation_",
							Texte = L["Enable area"] or "Enable area"
						},
						[2] = {
							Type = "Encoche",
							Etat = false,
							Nom = "Everywhere_",
							Texte = L["Everywhere"] or "Everywhere",
							Description = L["Everywhere_Desc"] or "Activate to enable alerts Everywhere",
							Scenario = {{["disable"] = "Arena_"}, {["disable"] = "Battleground_"}, {["disable"] = "World_"}},
						},
						[3] = {
							Type = "Encoche",
							Etat = true,
							Nom = "Arena_",
							Texte = L["Arena"] or "Arena",
							Description = L["Arena_Desc"] or "Activate to enable alerts in Arena",
						},
						[4] = {
							Type = "Encoche",
							Etat = true,
							Nom = "Battleground_",
							Texte = L["Battleground"] or "Battleground",
							Description = L["Battleground_Desc"] or "Activate to enable alerts in Battleground",
						},
						[5] = {
							Type = "Encoche",
							Etat = false,
							Nom = "World_",
							Texte = L["World"] or "World",
							Description = L["World_Desc"] or "Activate to enable alerts in the outside World",
						}
					},
					[3] = {
						[1] = {
							Type = "LigneDeSeparation",
							Nom = "ConditionActivation_",
							Texte = L["Enable condition"] or "Enable condition"
						},
						[2] = {
							Type = "Encoche",
							Etat = false,
							Nom = "TargetAndFocusOnly_",
							Texte = L["TargetAndFocus only"] or "TargetAndFocus only",
							Description = L["TargetAndFocusOnly_Desc"] or "Alerts only works on your actual Target or Focus",
						},
						[3] = {
							Type = "Encoche",
							Etat = false,
							Nom = "OnlyMe_",
							Texte = L["Only Me"] or "Only Me",
							Scenario = {{["func"] = function() GladiatorVoiceAlerter.log("At this time, OnlyMe is not effective and has been deactivated, until...") end}}
						}
					},
					[4] = {
						[1] = {
							Type = "LigneDeSeparation",
							Nom = "VoiceConfig_",
							Texte = L["Voice configuration"] or "Voice configuration"
						},
						[2] = {
							Type = "Deroulant",
							Etat = false,
							Nom = "DefaultVoiceSelect",
							Texte = L["Default Voice"] or "Default Voice",
							Multiplicateur = 4,
							Tableau = GladiatorVoiceAlerter.LanguageList
						}
					},
					[5] = {
						[1] = {
							Type = "LigneDeSeparation",
							Nom = "GenderConfig_",
							Texte = L["Gender Voice configuration"] or "Gender Voice configuration"
						},
						[2] = {
							Type = "Encoche",
							Etat = true,
							Nom = "EGDetect",
							Texte = L["Enable Gender Detection"] or "Enable Gender Detection",
							Scenario = {{["disable"] = "OMVoice"},{["disable"] = "ONVoice"}},
						},
						[3] = {
							Type = "Deroulant",
							Etat = false,
							Nom = "OMVoice",
							Texte = L["Opt./Male Voice"] or "Opt./Male Voice",
							Multiplicateur = 1.5,
							Tableau = GladiatorVoiceAlerter.LanguageList
						},
						[4] = {
							Type = "Deroulant",
							Etat = false,
							Nom = "ONVoice",
							Texte = L["Opt./Neutral Voice"] or "Opt./Neutral Voice",
							Multiplicateur = 1.5,
							Tableau = GladiatorVoiceAlerter.LanguageList
						},
					},
					[6] = {
						[1] = {
							Type = "LigneDeSeparation",
							Nom = "OutputConfig",
							Texte = L["Output Configuration"] or "Output Configuration"
						},
						[2] = {
							Type = "Encoche",
							Etat = true,
							Nom = "EOConfig",
							Texte = L["Enable Output Config"] or "Enable Output Config",
							Scenario = {{["disable"] = "CAOutput"}},
						},
						[3] = {
							Type = "Deroulant",
							Etat = false,
							Nom = "CAOutput",
							Texte = L["Output"] or "Output",
							Multiplicateur = 1,
							Tableau = GVA_OUTPUT,
						},
					}
				}
			},
			Abilities = {
			--[[
				-- SPELL_INTERRUPT = {
					-- Etat = false,
				-- }
			-- },
			--]]
				SPELL_MISCELLANEOUS = {
					-- [2] = {
						-- [1] = {
							-- Nom = "Deathknight",
							-- Type = "LigneDeSeparation",
							-- Texte = "|cffC41F3BDeath Knight|r"
						-- },
					-- },
				}
			},
			Custom = {
				-- NewSpell = {
					-- [2] = {
						-- [1] = {
							-- Nom = "test1",
							-- Type = "LigneDeSeparation",
							-- Texte = "test1"
						-- }
					-- }
				-- }
			},
			MenuLSM = {},
			Added = {},
			Info = {},
			Class = {}
		},
		Constructor = {
			First = {},
			AlwaysFalse = {},
			AlwaysTrue = {}
		}
	}
	GladiatorVoiceAlerter.MPP = MPP
---------------------------------------------------------------------------------------------------------
	GVA_DB.GVASpellOutDated = GladiatorVoiceAlerter.SpellOutDated
	local HAUTEUR_DES_CELLULES_PAR_DEFAUT = 25
	local LARGEUR_DES_CELLULES_PAR_DEFAUT = 170
-----------------------------MainGVAframe----------------------------------------------------------------
	local MainGVAframe = CreateFrame("Frame", "GVAFrame", UIParent)
	do
		tinsert(UISpecialFrames, "GVAFrame")
		MainGVAframe:SetSize(700,400)
		MainGVAframe:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		-- MainGVAframe:SetBackdrop({ bgFile = "Interface\\AddOns\\FloodyDump\\gfx\\zUnknow-Winter-test",
							-- edgeFile = "Interface\\AddOns\\FloodyDump\\gfx\\roth_Z-transp",
							-- edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
							tile = 1, tileSize = 16, edgeSize = 16,
							insets = { left = 5, right = 3, top = 4, bottom = 3 }
							})
		MainGVAframe:SetBackdropColor(0.1,0.1,0.2,0.8) -- r,v,b,opacity
		MainGVAframe:EnableMouse(true)
		MainGVAframe:SetMovable(true)
		MainGVAframe:RegisterForDrag("LeftButton")
		MainGVAframe:SetFrameStrata("MEDIUM")
		MainGVAframe:SetToplevel(true)
		MainGVAframe:SetPoint("CENTER")
		
		local MainModelFrame = CreateFrame("Frame", "MainModelFrameID", UIParent)
		tinsert(UISpecialFrames, "MainModelFrameID")
		MainModelFrame:SetSize(GVAFrame:GetSize())
		MainModelFrame:SetPoint("TOPLEFT", GVAFrame)
		MainGVAframe.MainModelFrame = MainModelFrame

		local MainModel = CreateFrame("PlayerModel", "MainModelID", MainModelFrameID)
		MainModel:SetSize(GVAFrame:GetSize())
		MainModel:SetFrameLevel(MainGVAframe:GetFrameLevel()-1)
		MainModel:SetPoint("CENTER")
		MainModel:ClearFog()
		MainModel:ClearModel()
		MainModel:SetDisplayInfo(39361)
		MainModel:SetPortraitZoom(0)
		MainModel:SetCamDistanceScale(1) -- 2
		MainModel:SetPosition(3,0,0)
		MainModel:SetRotation(0)
		MainGVAframe.MainModel = MainModel

		MainModelFrame:Hide()
		MainGVAframe:Hide()
	end
---------------------------------------------------------------------------------------------------------
	local function FrameFade(frame,InOut,duration) --InOut: 1 IN -1 OUT
		local AniFrame = frame:CreateAnimationGroup()

		local AnimEffectAlpha = AniFrame:CreateAnimation("Alpha")
		AnimEffectAlpha:SetSmoothing("IN")
		-- AnimEffectAlpha:SetChange(InOut)
		if InOut == 1 then
			AnimEffectAlpha:SetFromAlpha(0)
			AnimEffectAlpha:SetToAlpha(1)
		else
			AnimEffectAlpha:SetFromAlpha(1)
			AnimEffectAlpha:SetToAlpha(0)
		end
		AnimEffectAlpha:SetDuration(duration)
		
		AniFrame:SetLooping("NONE")
			if InOut == 1 then frame:Show()
			--;frame:SetAlpha(0)
			end
			AniFrame:Play()
			if InOut == 1 then AniFrame:SetScript("OnFinished", function() frame:SetAlpha(1) end) end
			if InOut == -1 then AniFrame:SetScript("OnFinished", function() frame:Hide() end) end
		return AniFrame
	end
------------T-A-B----S-C-R-O-L-L-I-N-G----F-R-A-M-E------------------------------------------------------
	local function BuildTabs(Cadre, Nom)
		MPP.Constructor.First[Nom] = true
		-- ScrollFrame
			--Individual Identification
			local ScrollFrame = Nom.."ScrollFrame"
			local ScrollFrameID = Nom.."_GVA_ScrollFrame"
		local ScrollFrame = CreateFrame("ScrollFrame", ScrollFrameID, Cadre)
			ScrollFrame:SetPoint("BOTTOMRIGHT", -5, 5)
		if MPP.MenuIn.Abilities[Nom] then
			ScrollFrame:SetPoint("TOPLEFT", 5, -20)
		else
			ScrollFrame:SetPoint("TOPLEFT", 5, -40)
		end
		ScrollFrame:EnableMouseWheel(true)
			--External Identification
			GladiatorVoiceAlerter[ScrollFrameID] = ScrollFrame
		ScrollFrame:Hide()

		if Nom == "Abilities" or Nom == "Added" or Nom == "General" then else
			-- ScrollBar
				--Individual Identification
				local ScrollBar = Nom.."ScrollBar"
				local ScrollBarID = Nom.."_GVA_ScrollBar"
			local ScrollBar = CreateFrame("Slider", ScrollBarID, ScrollFrame, "FDScrollBarTemplate")
			ScrollBar:SetPoint("TOPLEFT", MainGVAframe, "TOPRIGHT", 0, -56) 
			ScrollBar:SetPoint("BOTTOMLEFT", MainGVAframe, "BOTTOMRIGHT", 0, 16)

			if Nom == "SPELL_CAST_START" then ScrollBar:SetMinMaxValues(1, 500) -- *********** NEED ADAPTATIVE THINGS HERE : SCOTCH
			elseif Nom == "SPELL_CAST_SUCCESS" then ScrollBar:SetMinMaxValues(1, 1300) 
			elseif Nom == "SPELL_AURA_APPLIED" then ScrollBar:SetMinMaxValues(1, 850) 
			elseif Nom == "SPELL_AURA_REMOVED" then ScrollBar:SetMinMaxValues(1, 400) 
			else ScrollBar:SetMinMaxValues(1, 150) 
			end

			ScrollBar:SetValueStep(1) 
			ScrollBar.scrollStep = 1
			ScrollBar:SetValue(0)
			ScrollBar:SetWidth(16)
			ScrollBar:SetScript("OnValueChanged", function(self,value) ScrollFrame:SetVerticalScroll(value) end)
				--External Identification
				GladiatorVoiceAlerter[ScrollFrameID][ScrollBarID] = ScrollBar

			local Scrollbgn = ScrollBar:CreateTexture(nil, "BACKGROUND")
			Scrollbgn:SetAllPoints(ScrollBar)
			Scrollbgn:SetColorTexture(0.1,0.1,0.2,0.8)

			ScrollFrame:SetScript("OnMouseWheel", function(frame,value)
															local cur_val = ScrollBar:GetValue()
															local min_val, max_val = ScrollBar:GetMinMaxValues()

															if value < 0 and cur_val < max_val then
																cur_val = math.min(max_val, cur_val + 60)
																ScrollBar:SetValue(cur_val)
															elseif value > 0 and cur_val > min_val then
																cur_val = math.max(min_val, cur_val - 60)
																ScrollBar:SetValue(cur_val)
															end
														end)
		end
		-- ScrollContainer
			--Individual Identification
			local ScrollContainer = Nom.."ScrollContainer"
			local ScrollContainerID = Nom.."_GVA_ScrollContainer"
		local ScrollContainer = CreateFrame("Frame", ScrollContainerID, ScrollFrame)
		ScrollContainer:SetPoint("TOPLEFT")
		ScrollContainer:SetSize(ScrollFrame:GetSize())
			--External Identification
			GladiatorVoiceAlerter[ScrollFrameID][ScrollContainerID] = ScrollContainer

		ScrollFrame:SetScrollChild(ScrollContainer)

		return ScrollFrame, ScrollContainer, Nom
	end
---------------------------------------------------------------------------------------------------------
	-- Build Options
---------------------------------------------------------------------------------------------------------
	local GVA_Menu_Event = {["SPELL_CAST_SUCCESS"] 	= "Spell Cast Success",
							["SPELL_CAST_START"] 	= "Spell Cast Start",
							["SPELL_AURA_APPLIED"] 	= "Spell Aura Applied",
							["SPELL_AURA_REMOVED"] 	= "Spell Aura Removed"}
	local GVA_Menu_Class = {{["Deathknight"]	= "|cffC41F3BDeath Knight|r"},
							{["DemonHunter"]	= "|cffA330C9DemonHunter|r"},
							{["Druid"]			= "|cffFF7D0ADruid|r"},
							{["Hunter"] 		= "|cffABD473Hunter|r"},
							{["Mage"]			= "|cff69CCF0Mage|r"},
							{["Monk"]			= "|cFF00FF96Monk|r"},
							{["Paladin"]		= "|cffF58CBAPaladin|r"},
							{["Priest"]			= "|cffFFFFFFPriest|r"},
							{["Rogue"]			= "|cffFFF569Rogue|r"},
							{["Shaman"]			= "|cff0070DEShaman|r"},
							{["Warlock"]		= "|cff9482C9Warlock|r"},
							{["Warrior"]		= "|cffC79C6EWarrior|r"},
							{["Divers"]			= "|cffFFFFFFDivers|r"}
							}
		-- /dump GladiatorVoiceAlerter.MPP.MenuIn.Abilities.byEvent
	-- sort by Events
	MPP.MenuIn.Abilities["byEvent"] = {}
	for Event in pairs(GVA_Menu_Event) do
		MPP.MenuIn.Abilities.byEvent[Event] = {}
		for Num,b in pairs(GVA_Menu_Class) do
			for Class,ClassColored in pairs(b) do
				MPP.MenuIn.Abilities.byEvent[Event][Num] = { [1] = { Nom = Class, Texte = ClassColored, Type = "LigneDeSeparation" } }
			end
		end
	end
		-- /dump GladiatorVoiceAlerter.MPP.MenuIn.Abilities.byClass
	-- sort by Class
	MPP.MenuIn.Abilities["byClass"] = {}
	for Num,b in pairs(GVA_Menu_Class) do
		for Class,ClassColored in pairs(b) do
			MPP.MenuIn.Abilities.byClass[Class] = {}
			for Event,EventLocalised in pairs(GVA_Menu_Event) do
				MPP.MenuIn.Abilities.byClass[Class][Event] = { [1] = { Nom = Event, Texte = EventLocalised, Type = "LigneDeSeparation" } }
			end
		end
	end
---------------------------------------------------------------------------------------------------------
	-- Build Tabs
---------------------------------------------------------------------------------------------------------
	local TabFenetre, ScreenTabFenetre, NomFenetre, NomFenetreSimp = {}, {}
	do
		-- MenuTop! Tabs
		for MenuTop in pairs(MPP.MenuTop) do
			if MenuTop ~= "Close" then
				ScrollFrame, ScrollContainer, NomFenetreSimp = BuildTabs(MainGVAframe,MenuTop)
				TabFenetre[NomFenetreSimp] = ScrollContainer
				ScreenTabFenetre[NomFenetreSimp] = ScrollFrame
			end
		end
		-- Events Tabs
		for Event in pairs(GVA_Menu_Event) do
				ScrollFrame, ScrollContainer, NomFenetreSimp = BuildTabs(ScreenTabFenetre["Abilities"], Event)
				TabFenetre[NomFenetreSimp] = ScrollContainer
				ScreenTabFenetre[NomFenetreSimp] = ScrollFrame
		end
		-- Class Tabs
		for Order, a in pairs (GVA_Menu_Class) do
			for Class in pairs (a) do
				ScrollFrame, ScrollContainer, NomFenetreSimp = BuildTabs(ScreenTabFenetre["Abilities"], Class)
				TabFenetre[NomFenetreSimp] = ScrollContainer
				ScreenTabFenetre[NomFenetreSimp] = ScrollFrame
			end
		end
	end
	GladiatorVoiceAlerter.TabFenetre = TabFenetre
	GladiatorVoiceAlerter.ScreenTabFenetre = ScreenTabFenetre
---------------------------------------------------------------------------------------------------------
	-- Inject SpellList in Options 
---------------------------------------------------------------------------------------------------------
	do
		-- Search Class Order : 1, 2, 3, SOLEIL
		local ClassTabOrder = {} -- Utilité: Booaaff...
		for Special,z in pairs(MPP.MenuIn.Abilities) do
			for Event,c in pairs(z) do
				for CadreOrder,a in ipairs(c) do
					if a == "false" then break end
					for SpellOrder,b in ipairs(a) do
						for Clef,Valeur in pairs(b) do
							if Clef == "Nom" then
								ClassTabOrder[Valeur] = CadreOrder
							end
						end
					end
				end
			end
		end
		GladiatorVoiceAlerter.ClassTabOrder = ClassTabOrder
		-- Inject from SpellList to MPP
		local SpellList = GladiatorVoiceAlerter.GVA_SpellList
		for Event,a in pairs(SpellList) do
			for Class,b in pairs(a) do
				for SpellID,FileName in pairs(b) do
					local spellName = GetSpellInfo(SpellID)
					if ClassTabOrder[Class] then
						tinsert(MPP.MenuIn.Abilities.byEvent[Event][ClassTabOrder[Class]], { Type = "Encoche", Nom = FileName, Icone = SpellID, Texte = spellName, Scenario = "spell" }) -- Event 
						tinsert(MPP.MenuIn.Abilities.byClass[Class][Event], { Type = "Encoche", Nom = FileName, Icone = SpellID, Texte = spellName, Scenario = "spell" }) -- Class
					end
				end
			end
		end
		
	end
------------P-A-G-E----N-A-D-A---------------------------------------------------------------------------
	local function DessimemoilaPageNada(Fenetre)

		local Nyi = CreateFrame("Frame","Nyi_Frame_"..Fenetre,TabFenetre[Fenetre])
		Nyi:SetPoint("CENTER")--, 1, 1)
		Nyi:SetSize(400,50)
		-- Nyi:SetBackdrop({ edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32", edgeSize = 1	})
		local Nyi_text = Nyi:CreateFontString("Nyi_LOGO_"..Fenetre, "OVERLAY", "GameFontHighlight")
		Nyi_text:SetPoint("CENTER")
		Nyi_text:SetFontObject(GVAFontLogo)
		Nyi_text:SetText("|cffFFcF5FNot Yet Implemented !|r")
		
		local AnimNyi = Nyi:CreateAnimationGroup()

		-- BEGIN ROTATION -----------------------------------------------------
			local RotateNyi = AnimNyi:CreateAnimation("Rotation")
			RotateNyi:SetSmoothing("IN")
			RotateNyi:SetDuration(10)
			RotateNyi:SetDegrees(-715)
		-- END ROTATION -------------------------------------------------------

		local Logo = CreateFrame("Frame","Logo_Frame_"..Fenetre,TabFenetre[Fenetre])
		Logo:SetPoint("CENTER", 0, -20)
		Logo:SetSize(300,50)
		-- Logo:SetBackdrop({ edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32", edgeSize = 1	})

		local Logo_text = Logo:CreateFontString("Logo_text_"..Fenetre, "OVERLAY", "GameFontHighlight")
		Logo_text:SetPoint("CENTER")
		Logo_text:SetFontObject(GVAFontLogoMed)
		Logo_text:SetText("Awaa awaa awadama fever!")
		
		local AnimNyiLogo = Logo:CreateAnimationGroup()

		-- BEGIN ROTATION -----------------------------------------------------
			local RotateLogo = AnimNyiLogo:CreateAnimation("Rotation")
			RotateLogo:SetSmoothing("IN")
			RotateLogo:SetDuration(10)
			RotateLogo:SetDegrees(1715)
		-- END ROTATION -------------------------------------------------------

		local LogoGVA = CreateFrame("Frame","Logo_Frame_"..Fenetre,TabFenetre[Fenetre])
		LogoGVA:SetPoint("BOTTOMRIGHT", 30, -20)
		LogoGVA:SetSize(300,50)
		-- Logo:SetBackdrop({ edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32", edgeSize = 1	})

		local LogoGVA_text = LogoGVA:CreateFontString("Logo_text_"..Fenetre, "OVERLAY", "GameFontHighlight")
		LogoGVA_text:SetPoint("CENTER")
		LogoGVA_text:SetFontObject(GVAFontLogoLow)
		LogoGVA_text:SetText("|cffFF7D0AG|rladiator |cffFF7D0AV|roice |cffFF7D0AA|rlerter")
		
		local AnimLogoGVA = LogoGVA:CreateAnimationGroup()

		-- BEGIN PATH ---------------------------------------------------------
			local AnimLogoGVAPath = AnimLogoGVA:CreateAnimation("Translation")
			AnimLogoGVAPath:SetSmoothing("IN_OUT")
			AnimLogoGVAPath:SetDuration(1)
			AnimLogoGVAPath:SetOffset( 0, 5 )
		-- END PATH -----------------------------------------------------------

		local PowerBallFrame = CreateFrame("Frame","PowerBallFrameID",TabFenetre[Fenetre])
		PowerBallFrame:SetPoint("CENTER")--, 1, 1)
		PowerBallFrame:SetSize(700,400)
		
		local PowerBall = CreateFrame("PlayerModel", "PowerBallID", PowerBallFrame)
		PowerBall:SetSize(PowerBallFrame:GetSize())
		PowerBall:SetFrameLevel(Nyi:GetFrameLevel()-1)
		PowerBall:SetPoint("TOPLEFT")
		PowerBall:ClearFog()
		PowerBall:ClearModel()
		PowerBall:SetDisplayInfo(38699)
		PowerBall:SetPortraitZoom(0)
		PowerBall:SetCamDistanceScale(0.2) -- 2
		PowerBall:SetPosition(0,0,0)
		PowerBall:SetRotation(0)
	
		AnimNyi:SetLooping("BOUNCE")
		AnimNyiLogo:SetLooping("BOUNCE")
		AnimLogoGVA:SetLooping("BOUNCE")
	
		Nyi:SetScript("OnShow", function()
							-- PlaySoundKitID(69,"SFX",false)
							PlayMusic("Interface\\Addons\\GladiatorVoiceAlerter\\Gfx\\AwadamaFever.ogg")
							Nyi_text:SetPoint("CENTER")
							AnimNyi:Play()
							AnimNyiLogo:Play()
							AnimLogoGVA:Play()
						end)
		Nyi:SetScript("OnHide", function()
						StopMusic()
						end)
	end
------------P-A-G-E----D-'-I-N-F-O-----------------------------------------------------------------------
	local function DessinemoiUnePageInfo()

		local InfoFrame = CreateFrame("Frame", "InfoFrameID", TabFenetre["Added"])
		InfoFrame:Hide()
		InfoFrame:SetSize(500,270)
		InfoFrame:SetPoint("CENTER")
		InfoFrame:SetBackdrop({
			bgFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32",
			edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_BLACK-128-32",
			edgeSize = 1,
			insets = { left = -5, right = -5, top = -5, bottom = -5 },
			})
			
		local InfoLigneA = InfoFrame:CreateFontString("GVA_LOGO", "OVERLAY", "GameFontHighlight")
		InfoLigneA:SetPoint("LEFT",10,-60)
		InfoLigneA:SetFontObject(GVAFontPT_SN)
		InfoLigneA:SetJustifyH("LEFT")
		InfoLigneA:SetText("This is the |cffFF7D0ABêta|r release of Gladiator Voice Alerter which is booming !\nIt is therefore the right time to come and ask me to add functionality !\n \nWhat's up:\n- Various fix\n- Localization supported (still some prob with Korean and Chinese fonts : Todo!)\n- English(Julie-HP) voice removed from GVA into a standalone Voice Pack!\n\nHave fun with GVA, Support me and Kill them all !")
		-- La frame qu'on moove son body
		local Logo_ = CreateFrame("Frame","Logo_Frame",TabFenetre["Added"])
		Logo_:SetPoint("CENTER",0,0)
		Logo_:SetSize(550,50)

		-- Les textes dans la frame
		local Logo_text = Logo_:CreateFontString("GVA_LOGO", "OVERLAY", "GameFontHighlight")
		Logo_text:SetPoint("CENTER")
		Logo_text:SetFontObject(GVAFontLogo)
		Logo_text:SetText("|cffFF7D0AG|rladiator |cffFF7D0AV|roice |cffFF7D0AA|rlerter")
		local Logo_version = Logo_:CreateFontString("GVA_LOGO_VERSION", "OVERLAY", "GameFontHighlight")
		Logo_version:SetPoint("BOTTOMRIGHT",-50,-60)
		Logo_version:SetFontObject(GVAFontLogoVersion)
		Logo_version:SetText("|cffFF7D0ABêta 1.1|r") -- version
		local Logo_author = Logo_:CreateFontString("GVA_LOGO_VERSION", "OVERLAY", "GameFontHighlight")
		Logo_author:SetPoint("BOTTOMRIGHT",-100,-60)
		Logo_author:SetFontObject(GVAFontLogoLow)
		Logo_author:SetText("|cffddddddby Zuhligan|r")	

		-- On créé la baaase de l'anim
		local AnimLogo = Logo_:CreateAnimationGroup()
		local AnimLogo2 = Logo_:CreateAnimationGroup()

		-- Les animations que qu'on veut
		local AnimEffectRotate = AnimLogo:CreateAnimation("Rotation")
		AnimEffectRotate:SetSmoothing("IN")
		AnimEffectRotate:SetDuration(2)
		AnimEffectRotate:SetDegrees(359)
		local AnimEffectTrans = AnimLogo2:CreateAnimation("Translation")
		AnimEffectTrans:SetSmoothing("IN")
		AnimEffectTrans:SetOffset(0, 100)
		AnimEffectTrans:SetDuration(2)

		-- On prévoit ce qui arrivera à la fin
		AnimLogo:SetScript("OnFinished", function() AnimLogo2:Play() end)
		AnimLogo2:SetScript("OnFinished", function() Logo_:SetPoint("CENTER",0,100);FrameFade(InfoFrameID,1,1) end)

		-- GO SHOW
		Logo_:SetScript("OnShow", function()
							PlaySoundFile("Interface\\Addons\\GladiatorVoiceAlerter\\Gfx\\WelcomeToGVA.ogg", "SFX")
							Logo_:SetPoint("CENTER",0,0)
							AnimLogo:Play()
						end)
						
		-- On prévoit le néttoyage des canettes à la fin
		Logo_:SetScript("OnHide", function() Logo_:SetPoint("CENTER",0,0) end)
	
		-- local function InfoFrame()
		-- end
	end
------------L-I-G-N-E----D-E----S-E-P-A-R-A-T-I-O-N------------------------------------------------------
	local function DessinemoiUneLigneDeSeparation(Cadre,Nom,Texte,Place,Ligne)
		local Nom_, Denomination = Nom.."gva_HorizontalRule", "gva_horizontalrule_"..Nom
		local Nom_ = CreateFrame("Frame", Denomination, Cadre)
		Nom_:SetPoint("TOPLEFT", Place, Ligne)
		Nom_:SetSize(Cadre:GetWidth(), HAUTEUR_DES_CELLULES_PAR_DEFAUT)--GVAScrollFrame:GetWidth()-20)
		Nom_:SetBackdrop({
			bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
			-- edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32",edgeSize = 1,
			})
		Nom_:SetBackdropColor(0.1,0.1,0.2,0.5)
		
		local text = Nom_:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
		-- text:SetJustifyH("MIDDLE")
		text:SetPoint("TOPLEFT",2,-7)
			local GL = GetLocale() -- 								*** SCOTCH ***
			if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then --	*** SCOTCH ***
				text:SetFontObject(GameFontNormalLarge) --			*** SCOTCH ***
			else --													*** SCOTCH ***
				text:SetFontObject(GVAFont1) --						*** SCOTCH ***
			end --													*** SCOTCH ***
		-- text:SetFontObject(GVAFont1)
		local Texte = L[Texte] or Texte
		local H_Line = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_black-128-32"
		text:SetText("|T"..H_Line..":3:38|t|cffFFcF5F"..Texte.."|r|T"..H_Line..":3:700|t")

		MainGVAframe.Nom = Nom_
	end
------------B-O-U-T-O-N----P-O-U-S-S-O-I-R---------------------------------------------------------------
	local FirstAb, LastTime, LastFrame, LastButton = true, GetTime(), "Added"
	local function DessinemoiUnBoutonPoussoir(Cadre,Nom,Texte,Place,Ligne,TailleH,TailleL,Scenario,Caillou)
		local Nom_, Denomination = Nom.."Button", "gva_button_"..Nom
		local Nom_ = CreateFrame("Button", Denomination, Cadre, OriginalButtonTemplate)
		Nom_:SetPoint("TOPLEFT", Place, Ligne)
		local TailleH = TailleH or HAUTEUR_DES_CELLULES_PAR_DEFAUT
		local TailleL = TailleL or LARGEUR_DES_CELLULES_PAR_DEFAUT
		Nom_:SetSize(TailleL, TailleH)
				-- local GL = GetLocale() -- 								*** SCOTCH ***
				-- if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then --	*** SCOTCH ***
					-- Nom_:SetNormalFontObject("GameFontNormalLarge") --	*** SCOTCH ***
				-- else --													*** SCOTCH ***
					-- Nom_:SetNormalFontObject("GVAFont1") --				*** SCOTCH ***
				-- end --													*** SCOTCH ***
		Nom_:SetNormalFontObject("GVAFont1")
		Nom_:SetText(Texte)
		Nom_:SetBackdrop({
			edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_black-128-32",
			edgeSize = 1,
			})
		local model = CreateFrame("PlayerModel",nil,Nom_)
		model:SetSize(Nom_:GetSize())
		model:SetFrameLevel(Nom_:GetFrameLevel()-1)
		model:SetPoint("CENTER")
		model:ClearFog()
		model:ClearModel()
		Nom_:SetScript("OnEnter",
			function(self)
				model:SetDisplayInfo(28988)
				model:SetPortraitZoom(0)
				model:SetCamDistanceScale(1) -- 2
				model:SetPosition(-1,0,0)
				model:SetRotation(0)
				PlaySoundFile("Interface\\Addons\\GladiatorVoiceAlerter\\Gfx\\click4.ogg","MASTER")
			end)
		Nom_:SetScript("OnLeave",
			function(self)
				model:ClearFog()
				model:ClearModel()
			end)
		Nom_:SetScript("OnShow",
			function(self)
				model:ClearFog()
				model:ClearModel()
				if not Caillou then
					MPP.Constructor.AlwaysFalse.Etat = false
					Caillou = MPP.Constructor.AlwaysFalse
				end
				if Caillou.Etat == false then
					Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32")
					Nom_:SetPushedTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32")
					Nom_:SetDisabledTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_grey-128-32")
				else
					Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_grey-128-32")
					Nom_:SetPushedTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32")
					Nom_:SetDisabledTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_grey-128-32")
				end
			end)

		if Scenario ~= nil and Scenario ~= "AuTop!" then
			Nom_:SetScript("OnClick",Scenario)
		elseif Scenario == "AuTop!" then
			Nom_:SetScript("OnClick",function(self)
				if LastListeBG then LastListeBG:Hide() end
				local ActualTime = GetTime()
				local Diff = ActualTime - LastTime
				if Diff > 0.6 then
					if LastFrame and LastFrame ~= Nom then
						InfoFrameID:Hide()
						FrameFade(ScreenTabFenetre[LastFrame],-1,0.5)
						MPP.MenuTop[LastFrame].Etat = false
						LastButton = LastButton or Nom_
						LastButton:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32")
					end
					if Nom ~= LastFrame then
						if FirstAb then
								local GL = GetLocale() -- 															*** SCOTCH ***
								if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then --								*** SCOTCH ***
									DescriptionFilterSelectedEditBox:SetFontObject("GameFontNormalLarge") --		*** SCOTCH ***
								else --																				*** SCOTCH ***
									DescriptionFilterSelectedEditBox:SetFontObject("GVAFontLogoMed") --				*** SCOTCH ***
								end --																				*** SCOTCH ***
							-- DescriptionFilterSelectedEditBox:SetFontObject("GVAFontLogoMed") -- ***** C'EST MOCHE *****
							local CSUCCESS = L["Cast Success"] or "Cast Success"
							DescriptionFilterSelectedEditBox:SetText("|cffFFDDDD"..CSUCCESS.."|r") -- ***************
							ScreenTabFenetre["SPELL_CAST_SUCCESS"]:Show()
							FirstAb = false
						end
						FrameFade(ScreenTabFenetre[Nom],1,0.5)
						MPP.MenuTop[Nom].Etat = true
						Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_darkgrey-128-32")
					end
					LastFrame, LastTime, LastButton = Nom, ActualTime, Nom_
				else
					print("0.5999 sec max! Mad Clicker:",Diff,"sec")
				end
			end)
		else
			print(Nom.." : Pas de script, pas de chocolat!")
		end
		Nom_.model = model
		MainGVAframe.Nom_ = Nom_
	end
------------B-O-U-T-O-N----A----C-O-C-H-E-R--------------------------------------------------------------
	local function DessinemoiUnBoutonACocher(Cadre,Nom,Texte,Icone,Place,Ligne,TailleH,TailleL,Scenario,Description,Caillou)
		local Nom_, Denomination = Nom.."Button", "gva_button_"..Nom
		local Nom_ = CreateFrame("Button", Denomination, Cadre)

		local text = Nom_:CreateFontString(Nom.."FontString", "OVERLAY", "GameFontHighlight")
		if not Icone then text:SetPoint("BOTTOMLEFT",21,3)
		else text:SetPoint("BOTTOMLEFT",21,-1) end

		local GL = GetLocale() -- 										*** SCOTCH ***
		if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then else -- 	*** SCOTCH ***
			text:SetFontObject(GVAFontPT_SN) -- 						*** SCOTCH ***
		end -- 															*** SCOTCH ***

		local spellName,_,spellIcon = GetSpellInfo(Icone)
		Nom_:SetPoint("TOPLEFT", Place+4, Ligne-2)
		Nom_:SetSize(20,20)
		-- Frame:SetHitRectInsets(left, right, top, bottom)
		Nom_:SetHitRectInsets(0, -LARGEUR_DES_CELLULES_PAR_DEFAUT+20, 0, 0) -- Boite Killer
		-- Nom_:SetBackdrop({
			-- edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32",
			-- edgeSize = 1,
			-- })
		Nom_:SetHighlightTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-highlight", "ADD")
		Nom_:SetDisabledTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-highlight", "ADD") -- OLD-butt-highlight 
		Nom_:SetScript("OnShow", function(self)
									if GVA_IsDisabled[Denomination] then
										Nom_:Disable(); Nom_:EnableMouse(false)
										text:SetText("|cff444444"..Texte.."|r")
									else
										Nom_:Enable(); Nom_:EnableMouse(true)
										if not Icone then
											text:SetText("|cffeeeeee"..Texte.."|r")
										else
											if Texte then -- **************************************** SPARADRA
												if #Texte > 20 then
													Texte = string.sub(Texte, 1, 20)..("|cffC41F3B...|r")--#Texte.."|r")
												else
												end
												text:SetText("|T"..spellIcon..":22|t"..Texte)
											end
										end

										if GVA_DB[Nom] == false then
											Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-unchecked")
										elseif GVA_DB[Nom] == nil then
											Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-unchecked")
											print("|cff11FFAAGVA:|r Option: |cffff1111",Nom,"|r incorrectly set! (|cffff1111",GVA_DB[Nom],"|r) To prevent this, think to set it in GVADB_Defaults.")
											-- GVA_DB[Nom] = false -- Prevent error
										elseif GVA_DB[Nom] == "short" then
											Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-checked-short")
										elseif GVA_DB[Nom] == "long" then
											Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-checked-long")
										elseif GVA_DB[Nom] == true then
											Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-checked")
										else
											print("THIS can't happen!", Nom, GVA_DB[Nom])
										end
									end
								end)
	--BEGIN TOOLTIP
		-- CreateFrame("GameTooltip", "GVA_Tooltip", nil, "GVAGameTooltipTemplate")
		if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then -- 						*** SCOTCH ***
			CreateFrame("GameTooltip", "GVA_Tooltip", nil, "GameTooltipTemplate") -- 	*** SCOTCH ***
		else -- 																		*** SCOTCH ***
			CreateFrame("GameTooltip", "GVA_Tooltip", nil, "GVAGameTooltipTemplate") -- *** SCOTCH ***
		end -- 																			*** SCOTCH ***
		Nom_:SetScript("OnEnter", function(self)
									GVA_Tooltip:SetOwner(GVAFrame, "ANCHOR_TOPLEFT")
									GVA_Tooltip:SetBackdrop({	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
																edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_black-128-32",
																edgeSize = 1,
																})
									GVA_Tooltip:SetBackdropColor(0.1,0.1,0.2,0.8)
									if spellIcon then
										GVA_Tooltip:SetHyperlink(GetSpellLink(Icone))
										GVA_Tooltip:AddLine("|T"..spellIcon..":18|t ID |cffFF7DFA"..Icone.."|r",1,0,0,false)
										GVA_Tooltip:Show()
									else
										GVA_Tooltip:ClearLines()
										GVA_Tooltip:AddLine(Texte,1,0.9,0,false)
										GVA_Tooltip:AddLine(Description,1,1,1,false)
										GVA_Tooltip:Show()
									end
								end)
		Nom_:SetScript("OnLeave", function(self) GVA_Tooltip:Hide()	end)
	--END TOOLTIP
		local function Tougoudou()
			GVA_DB[Nom] = not GVA_DB[Nom]
			GladiatorVoiceAlerter:RefreshFrame()
			-- PlaySound("igMainMenuOptionCheckBoxOn")
			PlaySoundFile("Interface\\Addons\\GladiatorVoiceAlerter\\Gfx\\switch2.ogg","MASTER")
		end
		local function Tougaga()
			for order,a in pairs(Scenario) do
				for Type,Action in pairs(a) do
					if Type == "disable" then
						Action = "gva_button_"..Action
						if Nom == "Everywhere_" then -- SCOTCH
							GVA_IsDisabled[Action] = not GVA_DB.Everywhere_
						else
							GVA_IsDisabled[Action] = not GVA_IsDisabled[Action]
						end
					elseif Type == "func" then
						Action()
					end
				end
			end
			Tougoudou()
		end
		local function Tagada()
			if GVA_DB[Nom] == false then GVA_DB[Nom] = true
				PlaySoundFile("Interface\\Addons\\"..GladiatorVoiceAlerter.LanguagePath[GVA_DB.DefaultVoiceSelect].."\\"..Nom..".ogg","MASTER")
			elseif GVA_DB[Nom] == true then GVA_DB[Nom] = "short"
				PlaySoundFile("Interface\\Addons\\"..GladiatorVoiceAlerter.LanguagePath[GVA_DB.DefaultVoiceSelect].."\\"..Nom.."_s.ogg","MASTER")
			elseif GVA_DB[Nom] == "short" then GVA_DB[Nom] = false
			end
			-- PlaySound("igMainMenuOptionCheckBoxOn")
			PlaySoundFile("Interface\\Addons\\GladiatorVoiceAlerter\\Gfx\\click4.ogg","MASTER")
			GladiatorVoiceAlerter:RefreshFrame()
		end

		if Scenario ~= nil and Scenario ~= "spell" then
			Nom_:SetScript("OnClick", function() Tougaga() end)
		elseif Scenario == "spell" then
			Nom_:SetScript("OnClick",function(self) Tagada() end)
		elseif Scenario == nil then
			Nom_:SetScript("OnClick",function(self) Tougoudou() end)
		end
		
		MainGVAframe.Nom = Nom_
	end
------------B-O-I-T-E----T-E-X-T-E-----------------------------------------------------------------------
	local function DessinemoiUneBoiteDeTexte(Cadre,Nom,Texte,Place,Ligne,TailleH,TailleL,Scenario,Multiplicateur,Type)
		local EdBox = CreateFrame("EditBox",Nom.."EditBox",Cadre,InputBoxTemplate)
		local Multiplicateur = Multiplicateur or 1
		-- DisabledTexture, DisabledTextColor or DisabledFontObject
		-- EdBox:Disable()
		-- EdBox:EnableMouse(true)
		local TailleH = TailleH or HAUTEUR_DES_CELLULES_PAR_DEFAUT
		local TailleL = TailleL or LARGEUR_DES_CELLULES_PAR_DEFAUT
		EdBox:SetSize(TailleL*Multiplicateur,TailleH)
		EdBox:SetPoint("TOPLEFT",Place,Ligne)
		if Type == "Desc" then
			EdBox:Disable()
		else
		EdBox:SetBackdrop({bgFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32", 
								edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_black-128-32", 
								edgeSize = 1,
								-- insets = { left = 0, right = 2, top = 0, bottom = 2 }
								})
		end
		EdBox:SetAutoFocus(false)
		EdBox:SetMaxLetters(100)

			local GL = GetLocale() -- 										*** SCOTCH ***
			if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then --			*** SCOTCH ***
				EdBox:SetFontObject(GameFontWhiteSmall) --					*** SCOTCH ***
			else --															*** SCOTCH ***
				EdBox:SetFontObject(GVAFontPT_SN) --						*** SCOTCH ***
			end --															*** SCOTCH ***

		-- EdBox:SetFontObject(GVAFontPT_SN)
		EdBox:SetText(Texte)
		EdBox:SetScript("OnEnterPressed", Scenario)
		return EdBox,EdBox:GetText()
	end
	local DeroulTabLastTime, DeroulTabLastFrame = GetTime()
------------M-E-N-U----D-E-R-O-U-L-A-N-T-----------------------------------------------------------------
	if FirstAb then DeroulTabLastFrame = "SPELL_CAST_SUCCESS" end
	local function DessinemoiUnMenuDeroulant(Cadre,Nom,Texte,Place,Ligne,TailleH,TailleL,Scenario,Type,Multiplicateur,items)
		local items = items or {"Alpha","Bêta","Gamma","Delta","Epsilon","Zêta","Êta","Thêta"}
		local Nom_, Denomination = Nom.."Button", "gva_button_"..Nom
		local Nom_ = CreateFrame("Button", Denomination, Cadre, OriginalButtonTemplate)
		Nom_:SetPoint("TOPLEFT", Place, Ligne)
		local TailleH = TailleH or HAUTEUR_DES_CELLULES_PAR_DEFAUT
		local TailleL = TailleL or LARGEUR_DES_CELLULES_PAR_DEFAUT
		local Multiplicateur = Multiplicateur or 1
		TailleL = TailleL * Multiplicateur
		Nom_:SetSize(TailleL, TailleH)
		
				local GL = GetLocale() -- 								*** SCOTCH ***
				if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then --	*** SCOTCH ***
					Nom_:SetNormalFontObject("GameFontWhiteSmall") --	*** SCOTCH ***
				else --													*** SCOTCH ***
					Nom_:SetNormalFontObject("GVAFontPT_SN") --			*** SCOTCH ***
				end --													*** SCOTCH ***
		-- Nom_:SetNormalFontObject("GVAFontPT_SN")
		local Preselect = items[GVA_DB[Nom]] or ""
		Nom_:SetText("|cff026F02"..Texte..":|r "..Preselect)
		Nom_:SetDisabledFontObject("GVAFontPT_SN_Disabled")
		Nom_:SetBackdrop({
			edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_black-128-32",
			edgeSize = 1,
			})
		Nom_:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32")
		Nom_:SetPushedTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32")
		Nom_:SetDisabledTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_grey-128-32")

		local Butt_ = CreateFrame("Button", Denomination.."Butt_", Nom_, OriginalButtonTemplate)
		Butt_:SetPoint("TOPRIGHT",0,-5)
		Butt_:SetSize(25,25)
		Butt_:SetNormalTexture("Interface\\BUTTONS\\Arrow-Down-Up")
		Butt_:SetPushedTexture("Interface\\BUTTONS\\Arrow-Down-Down")
		Butt_:SetDisabledTexture("Interface\\BUTTONS\\Arrow-Down-Disabled")
		
		local ListeBG = CreateFrame("Frame","ListeBG_ID",MainGVAframe) --,Nom_)
		_, _, _, xOfs, yOfs = Nom_:GetPoint()
		ListeBG:SetPoint("TOPLEFT",xOfs+5,yOfs-TailleH*3+10-1)
		local count = 0
		for _ in pairs(items) do count = count + 1 end
		ListeBG:SetSize(TailleL,TailleH*count)
		ListeBG:SetBackdrop({
			edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_black-128-32",
			edgeSize = 1,
			})
		ListeBG:SetFrameStrata("TOOLTIP")
		ListeBG:Hide()

		local ListeBGTextu = ListeBG:CreateTexture(nil, "BACKGROUND")
		ListeBGTextu:SetAllPoints(ListeBG)
		ListeBGTextu:SetColorTexture(0.2,0.1,0.2,0.8)
		local i = 0
		local GOGOLisation = {
					["é"] = "e", ["ê"] = "e", ["ë"] = "e", ["è"] = "e",
					["à"] = "a", ["â"] = "a", ["ä"] = "a", ["á"] = "a",
					["ù"] = "u", ["ú"] = "u", ["û"] = "u", ["ü"] = "u",
					["ì"] = "i", ["í"] = "i", ["î"] = "i", ["ï"] = "i",
					[" "] = "",	 ["'"] = ""}
		for clef,valeur in pairs(items) do
			i = i + 1
			w = valeur;for s,t in pairs(GOGOLisation) do w = string.gsub(w,s,t) end
			local ItemButton = CreateFrame("Button",w.."ItemButton",ListeBG,OriginalButtonTemplate)
				local GL = GetLocale() -- 										*** SCOTCH ***
				if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then --			*** SCOTCH ***
					ItemButton:SetNormalFontObject("GameFontWhiteSmall") --		*** SCOTCH ***
				else --															*** SCOTCH ***
					ItemButton:SetNormalFontObject("GVAFontPT_SN") --			*** SCOTCH ***
				end --															*** SCOTCH ***
			ItemButton:SetText(valeur)
			ItemButton:SetSize(Nom_:GetSize())
			ItemButton:SetPoint("TOPLEFT",0,-TailleH*(i-1))
			ItemButton:SetHighlightTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32")
			ItemButton:SetPushedTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32")
			ItemButton:SetDisabledTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_grey-128-32")
			if Type == "General" then
				ItemButton:SetScript("OnClick",function() ListeBG:Hide(); Nom_:SetText("|cff22FF22"..Texte..":|r "..valeur); GVA_DB[Nom] = clef; PlaySound("igMainMenuOptionCheckBoxOn") end)
			elseif Type == "Abilities" then
				ItemButton:SetScript("OnClick",function(self)
						local GL = GetLocale() -- 															*** SCOTCH ***
						if GL == "koKR" or GL == "zhCN" or GL == "zhTW" then --								*** SCOTCH ***
							DescriptionFilterSelectedEditBox:SetFontObject("GameFontNormalLarge") --		*** SCOTCH ***
						else --																				*** SCOTCH ***
							DescriptionFilterSelectedEditBox:SetFontObject("GVAFontLogoMed") --				*** SCOTCH ***
						end --																				*** SCOTCH ***
					-- DescriptionFilterSelectedEditBox:SetFontObject("GVAFontLogoMed") -- ***** C'EST MOCHE *****
					DescriptionFilterSelectedEditBox:SetText("|cffFFDDDD"..valeur.."|r") -- ***************
					DescriptionFilterSelectedEditBox:Show()
					PlaySound("igMainMenuOptionCheckBoxOn")
					ListeBG:Hide()
					local ActualTime = GetTime()
					local Diff = ActualTime - DeroulTabLastTime
					if Diff > 0.6 then
						if DeroulTabLastFrame and DeroulTabLastFrame ~= clef then
							FrameFade(ScreenTabFenetre[DeroulTabLastFrame],-1,0.5)
						end
						if clef ~= DeroulTabLastFrame then
							FrameFade(ScreenTabFenetre[clef],1,0.5)
						end
						DeroulTabLastFrame, DeroulTabLastTime = clef, ActualTime
					else
						print("TROP TOT",Diff)
					end
				end)
				
			end
		end
		local function CacheCache()
			if LastListeBG then
				if LastListeBG == ListeBG then 
					if ListeBG:IsShown() then ListeBG:Hide() else ListeBG:Show() end
				else
					LastListeBG:Hide();ListeBG:Show()
				end
			else
				ListeBG:Show()
			end
			LastListeBG = ListeBG
		end
		-- GVA_IsDisabled[Denomination] = true
		Nom_:SetScript("OnShow", function()
			if GVA_IsDisabled[Denomination] then
				Nom_:Disable(); Nom_:EnableMouse(false)
				Butt_:Disable(); Butt_:EnableMouse(false)
				if LastListeBG then LastListeBG:Hide() end
			else
				Nom_:Enable(); Nom_:EnableMouse(true)
				Butt_:Enable(); Butt_:EnableMouse(true)
				Nom_:SetScript("OnMouseDown", function()
								Butt_:SetButtonState("PUSHED")
								PlaySoundFile("Interface\\Addons\\GladiatorVoiceAlerter\\Gfx\\switch6.ogg","MASTER")
								CacheCache()
								end)
				Nom_:SetScript("OnMouseUp", function() Butt_:SetButtonState("NORMAL") end)
			end
				Butt_:SetScript("OnClick", function() CacheCache() end)
		end)
	end

		MainGVAframe:SetScript("OnMouseDown", function(self)
													MainGVAframe:StartMoving()
													if LastListeBG then LastListeBG:Hide() end
												end)
		MainGVAframe:SetScript("OnMouseUp", MainGVAframe.StopMovingOrSizing)
		GladiatorVoiceAlerter.MainGVAframe = MainGVAframe
------------P-A-G-E----C-U-S-T-O-M-----------------------------------------------------------------------
	local CustomLastFrame
	local function DessinemoilaPageCustom()
		if not CACHEMOINOMDIDIOU then DessimemoilaPageNada("Custom"); return end
		local seconds = GetTime()
		local a,d = string.match(seconds, "(%d+).(%d+)")
		DessinemoiUnBoutonPoussoir(ScreenTabFenetre["Custom"],"pousspouss","NEW",0,0,nil,nil,function() tinsert(GladiatorVoiceAlerter.items, "Ajout"..a);GladiatorVoiceAlerter:RefreshFrame() end)

		local poubelle, bouttons = {}, {}
		local TreeFrame = CreateFrame("Frame","TreeFrameID",ScreenTabFenetre["Custom"])
		TreeFrame:SetSize(170,ScreenTabFenetre["Custom"]:GetHeight()-25)
		TreeFrame:SetPoint("TOPLEFT",0,-25)
		TreeFrame:SetBackdrop({bgFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32", 
								-- edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_black-128-32", edgeSize = 1, 
								insets = { left = 4, right = 4, top = 4, bottom = 2 }})
		local items = {"Ouno","Dos","Tres","Quatro","Cinqo"}
		GladiatorVoiceAlerter.items = items
		local TailleH = TailleH or HAUTEUR_DES_CELLULES_PAR_DEFAUT
		local TailleL = TailleL or LARGEUR_DES_CELLULES_PAR_DEFAUT
		table.foreach(bouttons, print)
		for i,v in ipairs(items) do
			local frame = v.."CSFrame"
			local frame = CreateFrame("ScrollingMessageFrame",v.."CustomSpellFrame",ScreenTabFenetre["Custom"])
			frame:Hide()
			frame:SetSize(ScreenTabFenetre["Custom"]:GetWidth()-170,ScreenTabFenetre["Custom"]:GetHeight())
			frame:SetPoint("TOPLEFT",170,0)
			frame:SetBackdrop({bgFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32", 
									-- edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_black-128-32", 
									edgeSize = 1,
									insets = { left = 0, right = 2, top = 0, bottom = 2 }
									})
			frame:SetFontObject(GVAFontPT_SN)
			frame:SetJustifyH("RIGHT")
			frame:AddMessage(v)
			DessinemoiUneLigneDeSeparation(frame,"actiontype","Type d'action",0,-10-(TailleH*3))
			eb1, blabla = DessinemoiUneBoiteDeTexte(frame,"Macro","Macro's name",10,-10,TailleH,TailleL,function() print(eb1:GetText()) end)
			eb2, blabla2 = DessinemoiUneBoiteDeTexte(frame,"EdBoxID","Spell ID",10+TailleL,-10,TailleH,TailleL,function() print(eb2:GetText()) end)
			DessinemoiUneLigneDeSeparation(frame,"actiontype","Type d'action",0,-10-(TailleH*3))
			eb3, blabla3 = DessinemoiUneBoiteDeTexte(frame,"Fichier","Interface\\AddOns\\GladiatorVoiceAlerter\\Voice_Custom\\Will-Demo.ogg",10,-10-TailleH,TailleH,TailleL*2,function() print(eb3:GetText()) end)
			DessinemoiUnBoutonPoussoir(frame,"TestSon","Ecouter",10+TailleL*2,-10-TailleH,nil,nil,function() PlaySoundFile(eb3:GetText(),"MASTER") end,Caillou)
			-- DessinemoiUnMenuDeroulant(frame,"LSMSound","Select a sound",10,-10-(TailleH*2),nil,nil,Scenario,Caillou,Multiplicateur)
			DessinemoiUneLigneDeSeparation(frame,"actiontype","Type d'action",0,-10-(TailleH*3))
			local pewpew = {	[1] = {SPELL_AURA_APPLIED = {
											Etat = false,
											Type = "Encoche",
											Nom = "SPELL_AURA_APPLIED",
											Texte = "AuraApplied",
											Place = 10,
											Ligne = -10-(TailleH*4)
											}},
								[2] = {SPELL_AURA_REMOVED = {
											Etat = false,
											Type = "Encoche",
											Nom = "SPELL_AURA_REMOVED",
											Texte = "AuraRemoved",
											Place = 10+TailleL,
											Ligne = -10-(TailleH*4)
											}},
								[3] = {SPELL_CAST_START = {
											Etat = false,
											Type = "Encoche",
											Nom = "SPELL_CAST_START",
											Texte = "CastStart",
											Place = 10+TailleL*2,
											Ligne = -10-(TailleH*4)
											}},
								[4] = {SPELL_CAST_SUCCESS = {
											Etat = false,
											Type = "Encoche",
											Nom = "SPELL_CAST_SUCCESS",
											Texte = "CastSuccess",
											Place = 10,
											Ligne = -10-(TailleH*5)
											}},
								[5] = {Interupt = {
											Etat = false,
											Type = "Encoche",
											Nom = "Interupt",
											Texte = "Interupt",
											Place = 10+TailleL,
											Ligne = -10-(TailleH*5)
											}},
							}
			pewpew.Etat = false
			DessinemoiUnBoutonACocher(frame,"UseSoundCoche","Use an existing sound",nil,10+TailleL,-10-(TailleH*2),nil,nil,Scenario,pewpew)
			for a,b in ipairs(pewpew) do
				for c,d in pairs(b) do
					local Caillou = pewpew[a][c]
					if Caillou.Type == "Encoche" then
						DessinemoiUnBoutonACocher(frame,Caillou.Nom,Caillou.Texte,nil,Caillou.Place,Caillou.Ligne,nil,nil,nil,Caillou)
					elseif Caillou.Type == "Deroulant" then
						-- DessinemoiUnMenuDeroulant(frame,Caillou.Nom,Caillou.Texte,Caillou.Place,Caillou.Ligne,Caillou.TailleH,Caillou.TailleL,Caillou.Scenario,Caillou,Caillou.Multiplicateur)
					elseif Caillou.Type == "BoiteTexte" then
						DessinemoiUneBoiteDeTexte(frame,Caillou.Nom,Caillou.Texte,Caillou.Place,Caillou.Ligne,Caillou.TailleH,Caillou.TailleL,Caillou.Scenario)
					end
				end
			end
			-- Arbre
			local ItemButton = CreateFrame("Button",v.."ItemButton",TreeFrame,OriginalButtonTemplate)
			ItemButton:SetNormalFontObject("GVAFontPT_SN")
			ItemButton:SetText(v)
			ItemButton:SetSize(TailleL,TailleH)
			ItemButton:SetPoint("TOPLEFT",0,-TailleH*(i-1))
			ItemButton:SetScript("OnClick", function() end)
			ItemButton:SetHighlightTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32")
			ItemButton:SetPushedTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32")
			ItemButton:SetDisabledTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_grey-128-32")
			ItemButton:SetScript("PostClick", function()
													frame:Show()
													if CustomLastFrame then CustomLastFrame:Hide() end
													CustomLastFrame = frame
												end)
			bouttons[v] = ItemButton
			local CloseItemButton = CreateFrame("Button",v.."CloseItemButton",ItemButton,OriginalButtonTemplate)
			CloseItemButton:SetSize(20,20)
			CloseItemButton:SetPoint("TOPRIGHT",-5,-3)
			CloseItemButton:SetNormalFontObject("GameFontWhiteSmall")
			-- CloseItemButton:SetText("|TInterface/FriendsFrame/UI-Toast-CloseButton-Up:26|t")
			CloseItemButton:SetText("|TInterface/GLUES/LOGIN/Glues-CheckBox-Check:18|t")
			-- CloseItemButton:SetText("|TInterface/Scenarios/ScenarioIcon-Fail:26|t")
			CloseItemButton:SetNormalTexture("Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_white-128-32")
			CloseItemButton:SetScript("PostClick", function()
								for j,w in ipairs(items) do
									if v == w then tremove(items,j) end
								end
								tinsert(poubelle,ItemButton)
								Chababal = FrameFade(ItemButton,-1,0.5)
								Chababal:SetScript("OnFinished", function()
																	ItemButton:Hide()
																	bouttons[v] = nil
																	local c = 0
																	for a,b in pairs(bouttons) do
																		c = c + 1
																		if b then
																			bouttons[a]:SetPoint("TOPLEFT",0,-TailleH*(c-1))
																		end
																	end
																end)
													end)
		end
	end
------------P-A-G-E----A-B-I-L-I-T-I-E-S-----------------------------------------------------------------
	local function DessinemoiLaPageAbilities()
		local PlaceAb = 1
		local ButTabEvent = {
			{Nom = "SPELL_AURA_APPLIED",	Texte = "Aura Applied", 	Etat = false}, -- atm Etat is Useless...
			{Nom = "SPELL_AURA_REMOVED",	Texte = "Aura Removed", 	Etat = false},
			{Nom = "SPELL_CAST_START",		Texte = "Cast Start", 		Etat = false},
			{Nom = "SPELL_CAST_SUCCESS",	Texte = "Cast Success", 	Etat = false},
			-- [5] = {Nom = "SPELL_MISCELLANEOUS",	Texte = "Miscellaneous", 	Etat = false},
			-- [5] = {Nom = "All",		Texte = "All",	Etat = false, Largeur = 30,		Scenario = function() print("All") end},
			-- [6] = {Nom = "None",	Texte = "Non",	Etat = false, Largeur = 30,		Scenario = function() print("None") end},
			-- [7] = {Nom = "Tooltip",	Texte = "Tt",	Etat = false, Largeur = 30,		Scenario = function() GladiatorVoiceAlerter.MainDB:ResetProfile();GladiatorVoiceAlerter:RefreshFrame();print("Options Reseted to Default.") end}
		}
		local ButTabClass = {
			{Nom = "Deathknight",	Texte = "|cffC41F3BDeath Knight|r",	Etat = false},
			{Nom = "DemonHunter",	Texte = "|cffA330C9DemonHunter|r",	Etat = false},
			{Nom = "Druid",			Texte = "|cffFF7D0ADruid|r", 		Etat = false},
			{Nom = "Hunter",		Texte = "|cffABD473Hunter|r",		Etat = false},
			{Nom = "Mage",			Texte = "|cff69CCF0Mage|r",			Etat = false},
			{Nom = "Monk",			Texte = "|cFF00FF96Monk|r",			Etat = false},
			{Nom = "Paladin",		Texte = "|cffF58CBAPaladin|r", 		Etat = false},
			{Nom = "Priest",		Texte = "|cffFFFFFFPriest|r",		Etat = false},
			{Nom = "Rogue",			Texte = "|cffFFF569Rogue|r", 		Etat = false},
			{Nom = "Shaman",		Texte = "|cff0070DEShaman|r",		Etat = false},
			{Nom = "Warlock",		Texte = "|cff9482C9Warlock|r",		Etat = false},
			{Nom = "Warrior",		Texte = "|cffC79C6EWarrior|r", 		Etat = false},
			{Nom = "Divers",		Texte = "|cffFFFFFFDivers|r", 		Etat = false},
		}

		local function ListDeCourse(Tab)
			local TabList = {}
			GladiatorVoiceAlerter.TabList = TabList
			for order in ipairs(Tab) do
				local Caillou = Tab[order]
				TabList[Caillou.Nom] = L[Caillou.Texte] or Caillou.Texte
			end
			return TabList
		end

		local TailleL = 150
		-- /!\ Under construction /!\
		DessinemoiUneBoiteDeTexte(TabFenetre["Abilities"],"DescriptionFilteredBy",L["FILTERED BY :"] or "FILTERED BY :",PlaceAb,0,TailleH,110,Scenario,1,"Desc")
		DessinemoiUnMenuDeroulant(TabFenetre["Abilities"],"TabAbilitiesMenuDeroulant",L["Event"] or "Event",PlaceAb+150-40,0,TailleH,TailleL,Scenario,"Abilities",1,ListDeCourse(ButTabEvent))
		DessinemoiUnMenuDeroulant(TabFenetre["Abilities"],"TabClassMenuDeroulant",L["Class"] or "Class",PlaceAb+150*2-40,0,TailleH,TailleL,Scenario,"Abilities",1,ListDeCourse(ButTabClass))
		DessinemoiUneBoiteDeTexte(TabFenetre["Abilities"],"DescriptionFilterSelected","--",PlaceAb+150*3-40,0,TailleH,200,Scenario,1.5,"Desc")
		
		local LeftFlyout = CreateFrame("Frame", "LeftMenuFlyout", MainGVAframe)
		LeftFlyout:SetSize(80,368)
		LeftFlyout:SetBackdrop({ bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
							-- edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
							tile = 1, tileSize = 16, edgeSize = 16,
							insets = { left = 5, right = 3, top = 4, bottom = 3 }
							})
		LeftFlyout:SetBackdropColor(0.1,0.1,0.2,0.8) -- r,v,b,opacité
		LeftFlyout:EnableMouse(true)
		LeftFlyout:SetToplevel(true)
		LeftFlyout:SetPoint("TOPLEFT", GVAFrame,-75,-32)
		LeftFlyout:SetFrameLevel(MainGVAframe:GetFrameLevel()+1)
		LeftFlyout:Hide()

------------CONFIRM FRAME-----------------------------------------------------------------------
			local ConfirmFrame = CreateFrame("Frame", "GVA_ConfirmationFrame", MainGVAframe)
			ConfirmFrame:Hide()
			ConfirmFrame:SetSize(350,100)
			ConfirmFrame:SetPoint("CENTER")
			ConfirmFrame:SetFrameStrata("TOOLTIP")
			ConfirmFrame:SetBackdrop({
				bgFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_red-128-32_FlatTest",
				edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_BLACK-128-32",
				edgeSize = 1,
				insets = { left = -5, right = -5, top = -5, bottom = -5 },
				})

			local ConfirmFrame_text_AYS = ConfirmFrame:CreateFontString("ConfirmFrame_Text_AYS", "OVERLAY", "GameFontHighlight")
			ConfirmFrame_text_AYS:SetPoint("TOP",0,-10)
			ConfirmFrame_text_AYS:SetFontObject(GVAFontLogoMed)
			ConfirmFrame_text_AYS:SetText(L["Are you sure?"] or "Are you sure?")

			local ConfirmFrame_text = ConfirmFrame:CreateFontString("ConfirmFrame_Text", "OVERLAY", "GameFontHighlight")
			ConfirmFrame_text:SetPoint("CENTER")
			ConfirmFrame_text:SetFontObject(GVAFontPT_SN)
			-- ConfirmFrame_text:SetText("This will reset ALL options to default!")

			local ConfirmYes = CreateFrame("Button", "GVA_ConfirmationFrame_Button_Yes", GVA_ConfirmationFrame, OriginalButtonTemplate)
			ConfirmYes:SetBackdrop({
					bgFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_BLACK-128-32",
					edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_BLACK-128-32",
					edgeSize = 1,
					-- insets = { left = -5, right = -5, top = -5, bottom = -5 },
					})
			ConfirmYes:SetPoint("BOTTOMLEFT",10,-15)
			ConfirmYes:SetSize(70, 30)
			ConfirmYes:SetNormalFontObject("GVAFont1")
			ConfirmYes:SetText("Yes")


			local ConfirmNo = CreateFrame("Button", "GVA_ConfirmationFrame_Button_No", GVA_ConfirmationFrame, OriginalButtonTemplate)
			ConfirmNo:SetBackdrop({
					bgFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_BLACK-128-32",
					edgeFile = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\text_BLACK-128-32",
					edgeSize = 1,
					-- insets = { left = -5, right = -5, top = -5, bottom = -5 },
					})
			ConfirmNo:SetPoint("BOTTOMRIGHT",-10,-15)
			ConfirmNo:SetSize(70, 30)
			ConfirmNo:SetNormalFontObject("GVAFont1")
			ConfirmNo:SetText("No")

		local function AskOneThing(texte,action)
			local result
			ConfirmFrame_text:SetText(texte)
			GVA_ConfirmationFrame:Show()
			ConfirmYes:SetScript("OnClick", function() 	GVA_ConfirmationFrame:Hide()
											if action then
												action()
												return false
											else
												return true
											end
								end)
			ConfirmNo:SetScript("OnClick", function() GVA_ConfirmationFrame:Hide(); result = false end )
		end
------------CONFIRM FRAME-----------------------------------------------------------------------

		ButTabLeft = {
		{Nom = "All_Full",	Texte = "All |TInterface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-checked:20|t",	x = 7, y = -6, Etat = false, Hauteur = 36, Largeur = 68,
					Scenario = function() 
									AskOneThing(L["Ask_All_Full"] or "This will  |cffff1111set ALL spells options|r  to Full Names !",
												function()
													for Event,a in pairs(GladiatorVoiceAlerter.FastSpellList) do
														for SpellID,fileName in pairs(a) do
															GVA_DB[fileName] = true
														end
													end
													GladiatorVoiceAlerter:RefreshFrame()
													GladiatorVoiceAlerter.log(L["Ask_All_Full_Done"] or "ALL spells options setted to Full Name.")
												end)
								end},
		{Nom = "All_Small",	Texte = "All |TInterface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-checked-short:20|t",	x = 7, y = -6-40, Etat = false, Hauteur = 36, Largeur = 68,
					Scenario = function() 
									AskOneThing(L["Ask_All_Small"] or "This will  |cffff1111set ALL eligible spells options|r  to Shortened Names !",
												function()
													for Event,a in pairs(GladiatorVoiceAlerter.FastSpellList) do
														for SpellID,fileName in pairs(a) do
															if GladiatorVoiceAlerter.GVA_SpellList_Shortened[fileName] then
																GVA_DB[fileName] = "short"
															else
																GVA_DB[fileName] = true
															end
														end
													end
													GladiatorVoiceAlerter:RefreshFrame()
													GladiatorVoiceAlerter.log(L["Ask_All_Small_Done"] or "ALL eligible spells options setted to Shortened Name.")
												end)
								end},
		{Nom = "None",		Texte = "All |TInterface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\butt-unchecked:20|t",	x = 7, y = -6-40*2, Etat = false, Hauteur = 36, Largeur = 68,
					Scenario = function() 
									AskOneThing(L["Ask_None"] or "This will  |cffff1111un-set ALL spells options|r  !",
												function()
													for Event,a in pairs(GladiatorVoiceAlerter.FastSpellList) do
														for SpellID,fileName in pairs(a) do
															GVA_DB[fileName] = false
														end
													end
													GladiatorVoiceAlerter:RefreshFrame()
													GladiatorVoiceAlerter.log(L["Ask_None_Done"] or "ALL spells options setted to None.")
												end)
								end},
		{Nom = "Reset",		Texte = "Raz",	x = 7, y = -6-40*8, Etat = false, Hauteur = 36, Largeur = 68,
					Scenario = function() 
									AskOneThing(L["Ask_Reset"] or "This will  |cffff1111reset ALL OPTIONS|r  to default!",
												function()
													GladiatorVoiceAlerter.MainDB:ResetProfile()
													GVA_IsDisabled = { -- ** SCOTCH **
														gva_button_World_ = false,
														gva_button_ONVoice = true,
														gva_button_OMVoice = true,
														gva_button_Arena_ = false,
														gva_button_Battleground_ = false,
														gva_button_CAOutput = true
													}
													if self.db.profile.minimap.hide then GladiatorVoiceAlerter:CommandTheBunnies() end
													GladiatorVoiceAlerter:RefreshFrame()
													GladiatorVoiceAlerter.log(L["Ask_Reset_Done"] or "Options Resetted to Default.")
												end)
								end} }
		for order in pairs(ButTabLeft) do
			local Caillou = ButTabLeft[order]
			DessinemoiUnBoutonPoussoir(LeftMenuFlyout,Caillou.Nom,Caillou.Texte,Caillou.x,Caillou.y,Caillou.Hauteur,Caillou.Largeur,Caillou.Scenario)--,Caillou)
		end
		TabFenetre["Abilities"]:SetScript("OnShow", function() LeftMenuFlyout:Show() end) --*********------H-I-D-D-E-N------*********--
		TabFenetre["Abilities"]:SetScript("OnHide", function() LeftMenuFlyout:Hide() end)
	end
------------E-N----A-V-A-N-T----G-U-I-N-G-A-M-P----------------------------------------------------------
	local function DessinemoiLesOptions(Frame,Place,Ligne,H_Count,Caillou)
		if Caillou.Type == "LigneDeSeparation" then
			Place = 5;
			if MPP.Constructor.First[Frame] then
				if Frame == "General" then	Ligne = -6 else Ligne = 6 end -- SCOTCH! : A bosser
				MPP.Constructor.First[Frame] = false
			else Ligne = Ligne - HAUTEUR_DES_CELLULES_PAR_DEFAUT
			end
			DessinemoiUneLigneDeSeparation(	TabFenetre[Frame],
											Caillou.Nom,
											Caillou.Texte,
											Place,
											Ligne
										)
			Ligne = Ligne - HAUTEUR_DES_CELLULES_PAR_DEFAUT
			H_Count = 1
		elseif Caillou.Type == "Encoche" then
		if H_Count > 4 then H_Count = 1; Place = 5; Ligne = Ligne - HAUTEUR_DES_CELLULES_PAR_DEFAUT end
			DessinemoiUnBoutonACocher(	TabFenetre[Frame],
										Caillou.Nom,
										Caillou.Texte,
										Caillou.Icone,
										Place,
										Ligne,
										Caillou.TailleH,
										Caillou.TailleL,
										Caillou.Scenario,
										Caillou.Description,
										Caillou
									)
			H_Count = H_Count + 1;Place = Place + LARGEUR_DES_CELLULES_PAR_DEFAUT
		elseif Caillou.Type == "Poussoir" then
		if H_Count > 4 then H_Count = 1; Place = 5; Ligne = Ligne - HAUTEUR_DES_CELLULES_PAR_DEFAUT end
			DessinemoiUnBoutonPoussoir(	TabFenetre[Frame],
										Caillou.Nom,
										Caillou.Texte,
										Place,
										Ligne,
										Caillou.TailleH,
										Caillou.TailleL,
										Caillou.Scenario,
										Caillou
									)
		elseif Caillou.Type == "Deroulant" then
		if H_Count > 4 then H_Count = 1; Place = 5; Ligne = Ligne - HAUTEUR_DES_CELLULES_PAR_DEFAUT end
			DessinemoiUnMenuDeroulant(	TabFenetre[Frame],
										Caillou.Nom,
										Caillou.Texte,
										Place,
										Ligne,
										TailleH,TailleL,Scenario,--Caillou,
										"General",--Type : NEW
										Caillou.Multiplicateur,
										Caillou.Tableau
									)
			local T_Count = Caillou.Multiplicateur or 1
			H_Count = H_Count + T_Count;Place = Place + LARGEUR_DES_CELLULES_PAR_DEFAUT * T_Count
		end
		return Place,Ligne,H_Count,Caillou
	end
---------------------------------------------------------------------------------------------------------
	for MENU in pairs(MPP) do
		if MENU == "MenuTop" then
			for MENUTAB in pairs(MPP[MENU]) do
				local Caillou = MPP[MENU][MENUTAB]
				DessinemoiUnBoutonPoussoir(	GVAFrame,
											MENUTAB,
											Caillou.Texte,
											Caillou.Place,
											-6, -- Ligne
											Caillou.TailleH,
											Caillou.TailleL,
											Caillou.Scenario,
											Caillou)
			end
		elseif MENU == "MenuIn" then
			for MENUTAB,a in pairs(MPP[MENU]) do
			MPP.Constructor.First[MENUTAB] = true
				local H_Count,Place,Ligne,Caillou = 1,5,-6 -- V_Count, Ab45
				for Special,b in pairs(a) do
					MPP.Constructor.First[Special] = true -- Voice? sans s
					if MENUTAB == "General" then
						for Cadre,c in ipairs(b) do
							for Cellule in ipairs(c) do
								Caillou =  MPP[MENU][MENUTAB][Special][Cadre][Cellule] -- pour retrouver le chemin!

								if Caillou.Scenario then --Detect & inject Disabled/Enabled button in GVA_IsDisabled : SCOTCH
									for order,a in pairs(Caillou.Scenario) do
										for Type,Action in pairs(a) do
											if Type == "disable" then
												if Caillou.Nom == "Everywhere_" then -- la PALME du truc surper TORDU : SCOTCH
													if GVA_DB[Caillou.Nom] then
														Action = "gva_button_"..Action
														GVA_IsDisabled[Action] = true
													end
												else
													if not GVA_DB[Caillou.Nom] then
														Action = "gva_button_"..Action
														GVA_IsDisabled[Action] = true
													end
												end
											end
										end
									end
								end
								Place,Ligne,H_Count,Caillou = DessinemoiLesOptions(Special,Place,Ligne,H_Count,Caillou)
							end
						end
					elseif  MENUTAB == "Abilities" then
						if Special == "byEvent" then
							for Event,c in pairs(b) do
							MPP.Constructor.First[Event] = true -- Voice? sans s
								for Cadre,d in pairs(c) do
									for Cellule,e in pairs(d) do
										Caillou = MPP[MENU][MENUTAB][Special][Event][Cadre][Cellule]
										Place,Ligne,H_Count,Caillou = DessinemoiLesOptions(Event,Place,Ligne,H_Count,Caillou)
									end
								end
							end
						elseif Special == "byClass" then
							for Class,c in pairs(b) do
								for Event,d in pairs(c) do
									for Cellule,e in pairs(d) do
										Caillou =  MPP[MENU][MENUTAB][Special][Class][Event][Cellule]
										Place,Ligne,H_Count,Caillou = DessinemoiLesOptions(Class,Place,Ligne,H_Count,Caillou)
									end
								end
							end
						end
					end
				end
			end
		end
	end

	-- local TESTtexture = GladiatorVoiceAlerter.TabFenetre["Warlock"]:CreateTexture() 
	-- TESTtexture:SetAllPoints() 
	-- TESTtexture:SetTexture("Interface\\GLUES\\MainMenu\\Glues-BlizzardLogo")

	DessinemoiLaPageAbilities()
	DessinemoiUnePageInfo()
	DessimemoilaPageNada("MenuLSM")
	DessimemoilaPageNada("Info")
--//
	DessinemoilaPageCustom()
--//
	FrameFade(ScreenTabFenetre["Added"],1,0.5)

	-- print(GladiatorVoiceAlerter.MainGVAframe:GetChildren())
	-- print(GladiatorVoiceAlerter.MainGVAframe:GetNumChildren() )
	-- /script print(GladiatorVoiceAlerter.MainGVAframe:GetNumChildren() )
	-- 31 -- 386 -- 741 diff : 355 dans byEvent/byClass
end